// --------------------------------------------------------------------------
// Citadel: CfgFiles.h
//
// For figuring out how to configure ourselves.

#ifdef MAIN
char *citfiles[] =
	{
	"GRPDATA.CIT",      "EXTERNAL.CIT",     "CONFIG.CIT",
	"CRON.CIT",         "ROUTE.CIT",        "HARDWARE.CIT",
	"NODES.CIT",        "FILEQTMP.CIT",     "DEFUSER.CIT",
	"CRASH.CIT",        "MAILLIST.CIT",     "PROTOCOL.CIT",
	"MDMRESLT.CIT",     "NETID.CIT",        "MCI.CIT",
	"TERMCAP.CIT",		"COMMANDS.CIT",

	NULL
	};
#else
extern char *citfiles[];
#endif

enum
	{
	C_GRPDATA_CIT,		C_EXTERNAL_CIT, 	C_CONFIG_CIT,
	C_CRON_CIT, 		C_ROUTE_CIT,		C_HARDWARE_CIT,
	C_NODES_CIT,		C_FILEQTMP_CIT, 	C_DEFUSER_CIT,
	C_CRASH_CIT,		C_MAILLIST_CIT, 	C_PROTOCOL_CIT,
	C_MDMRESLT_CIT, 	C_NETID_CIT,		C_MCI_CIT,
	C_TERMCAP_CIT,		C_COMMANDS_CIT,

	MAXCIT,
	};

enum
	{
	GRK_DAYS,			GRK_GROUP,			GRK_HOURS,
	GRK_DAYINC, 		GRK_SPECIAL,		GRK_PRIORITY,
	GRK_MAXBAL, 		GRK_DLMULT, 		GRK_ULMULT,

	GRK_NUM
	};

enum
	{
	EC_EDITOR,			EC_USERAPP, 		EC_AUTO_EDITOR,
	EC_REPLACE, 		EC_DOOR,			EC_C_AUTHOR,
	EC_C_NODE,			EC_C_TEXT,			EC_HOLIDAY,
	EC_HOLIDAYWITHYEAR, EC_EVENT,			EC_ARCHIVER,
	EC_DIRECTORY,		EC_RLM, 			EC_REFUSER,
	EC_NETCOMMAND,		EC_BANPORT,

	EC_NUM
	};

enum
	{
	PR_PROTOCOL,		PR_MENU_NAME,		PR_COMMAND_KEY,
	PR_BATCH,			PR_BLOCK_SIZE,		PR_RECEIVE,
	PR_SEND,			PR_AUTO_UPLOAD, 	PR_RESPONSE_SEND,
	PR_NET_ONLY,		PR_CHECK_TRANSFER,

	PR_NUM
	};


enum
	{
	DUK_FORWARD,		DUK_SURNAME,		DUK_TITLE,
	DUK_BOLD,			DUK_NULLS,			DUK_WIDTH,
	DUK_CREDITS,		DUK_INVERSE,		DUK_BLINK,
	DUK_UNDERLINE,		DUK_PROTOCOL,		DUK_PROMPT,
	DUK_DSTAMP, 		DUK_VDSTAMP,		DUK_SIGNATURE,
	DUK_NETPREFIX,		DUK_ADDR2,			DUK_ADDR3,
	DUK_POOP,			DUK_UCMASK, 		DUK_EXPERT,
	DUK_AIDE,			DUK_TABS,			DUK_OLDTOO,
	DUK_UNLISTED,		DUK_PERMANENT,		DUK_SYSOP,
	DUK_NODE,			DUK_NOACCOUNT,		DUK_NOMAIL,
	DUK_ROOMTELL,		DUK_BORDERS,		DUK_VERIFIED,
	DUK_SURNAMLOK,		DUK_LOCKHALL,		DUK_DISPLAYTS,
	DUK_SUBJECTS,		DUK_SIGNATURES, 	DUK_DEFAULTHALL,
	DUK_LINESSCREEN,	DUK_FORWARDNODE,	DUK_ADDR1,
	DUK_LFMASK, 		DUK_PROBLEM,		DUK_NETUSER,
	DUK_NEXTHALL,		DUK_PSYCHO, 		DUK_TWIRLY,
	DUK_VERBOSE,		DUK_MSGPAUSE,		DUK_MINIBIN,
	DUK_MSGCLS, 		DUK_ROOMINFO,		DUK_HALLTELL,
	DUK_VERBOSECONT,	DUK_VIEWCENSOR, 	DUK_SEEBORDERS,
	DUK_OUT300, 		DUK_LOCKUSIG,		DUK_HIDEEXCL,
	DUK_NODOWNLOAD, 	DUK_NOUPLOAD,		DUK_NOCHAT,
	DUK_PRINTFILE,		DUK_REALNAME,		DUK_PHONENUM,
	DUK_SPELLCHECK, 	DUK_NOMAKEROOM, 	DUK_VERBOSELO,
	DUK_CONFSAVE,		DUK_CONFABORT,		DUK_CONFEOABORT,
	DUK_USEPERSONAL,	DUK_YOUAREHERE, 	DUK_IBMROOM,
	DUK_WIDEROOM,		DUK_MUSIC,			DUK_MOREPROMPT,
	DUK_NUMUSERSHOW,	DUK_CALLLIMIT,		DUK_CHECKAPS,
	DUK_CHECKALLCAPS,	DUK_CHECKDIGITS,	DUK_EXCLUDEENCRYPTED,
	DUK_SHOWCOMMAS, 	DUK_PUNPAUSES,		DUK_KUSER,
	DUK_KTEXT,			DUK_KNODE,			DUK_KREG,
	DUK_TUSER,			DUK_DICTWORD,		DUK_FINGER,
	DUK_USERDEF,		DUK_REPLACE,		DUK_NORMAL,
	DUK_ROMAN,			DUK_TERMTYPE,		DUK_SUPERSYSOP,
	DUK_BUNNY,			DUK_SSE_LOGONOFF,	DUK_SSE_NEWMSG,
	DUK_SSE_EXCLMSG,	DUK_SSE_CHATALL,	DUK_SSE_CHATROOM,
	DUK_SSE_CHATGROUP,	DUK_SSE_CHATUSER,	DUK_SSE_RMINOUT,
	DUK_BANNED,			DUK_KILLOWN,		DUK_SEEOWNCHATS,
    DUK_ERASEPROMPT,    DUK_AUTOIDLESECONDS, DUK_SSE_MSGSOMEWHERE,

	DUK_NUM
	};

enum TermCapCitE
	{
	TCK_TERMINAL,		TCK_IBMUPPER,		TCK_COLOR,
	TCK_TERMTYPE,		TCK_CLS,			TCK_FORECOLOR,
	TCK_BACKCOLOR,		TCK_FULLCOLOR,		TCK_HIGHFORECOLOR,
	TCK_HIGHBOTHCOLOR,	TCK_UNDERLINE,		TCK_BLINK,
	TCK_NORMAL,			TCK_REVERSE,		TCK_BOLD,
	TCK_DELEOL,			TCK_SAVECURS,		TCK_RESTORECURS,
	TCK_BLANKFOR1CURS,	TCK_CURSUP,			TCK_CURSDOWN,
	TCK_CURSLEFT,		TCK_CURSRIGHT,		TCK_ROWSTART,
	TCK_COLSTART,		TCK_BLANKFORTLCUR,	TCK_ABSCURSPOS,

	TCK_NUM
	};

#define CONFIGDDSTART 1
#define CONFIGDDEND 7

#define GRPDATADDSTART 8
#define GRPDATADDEND 8

#define EXTERNALDDSTART 9
#define EXTERNALDDEND 10

#define PROTOCOLDDSTART 11
#define PROTOCOLDDEND 11

#define MDMRESLTDDSTART 12
#define MDMRESLTDDEND 12

#define MCIDDSTART 13
#define MCIDDEND 13

#define COMMANDSDDSTART 14
#define COMMANDSDDEND 14
